from flake8_one_dot import Plugin
from typing import Set
from ast import parse
import pytest


def _results(s: str) -> Set[str]:
    tree = parse(s)
    plugin = Plugin(tree=tree)
    return {f'{line}:{col} {msg}' for line, col, msg, _ in plugin.run()}


def test_():
    assert _results('') == set()


@pytest.mark.parametrize('path,expected', [
    ('./tests/masters/method_chain.py', {'2:1 FOD100 Too many dots per line: 3 dots found'}),
    ('./tests/masters/more_dots.py', {'1:1 FOD100 Too many dots per line: 3 dots found'}),
])
def test_fails_for_else(path, expected):
    with open(path, 'r') as file:
        func = file.read()
    ret = _results(func)
    assert ret == expected
